unit main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  N = 256;                  // ̎ސ
  CHARBITS  = 8;            // 1oCg̃rbg
  BRANCH    = N - 2;        // }̐  0 ` 254     255
  MNSIZE    = 2 * N - 2;    // z̏l 0`510  511
var
  heapsize : integer;                       // D҂spq[vTCY
  heap    : array[0..MNSIZE] of integer;    // D҂spq[vz
  parent  : array[0..MNSIZE] of integer;    // Huffman
  left    : array[0..BRANCH] of integer;    // ̎}
  right   : array[0..BRANCH] of integer;    // E̎}
  freq    : array[0..MNSIZE] of cardinal;   // el(0`$FF)̏opx

  infile, outfile, testfile : Thandle;    // ̓t@C, o̓t@C
  outcount        : cardinal;             // o̓oCgJE^
  getcount        : byte;                 // rbg̓JE^
  putcount        : byte;                 // rbgo̓JE^
  bitbuf          : byte;                 // rbgo̓obt@
  avail           : integer;              // ؂̐߂̐JEg
  TReeF           : byte;                 // ؂̏݃G[tO
  WBF             : Word;

function rightbits(n, x: byte): byte;     // x̉Enrbg
var
  u : byte;
begin
  u := 1;
  u := (u shl n) - 1;       // 1 n=4 Vtg BIN 00000001 => 00010000 - 1 -> 00001111
  result := x and u;        // x̉ʃrbgo
end;

procedure error(massage : pchar);        // bZ[Wo
begin
  application.MessageBox(massage, '', 0);
end;

procedure testbitout;      // o̓rbgmFp t@CɃrbg񏑂o
var
  i     : integer;
  t, b  : byte;
  c, d  : word;
begin
  t := bitbuf;
  c := 49;                              // '1'
  d := 48;                              // '0'
  for i := 1 to CHARBITS do begin       // 8
    b := t and 128;                     // bin 10000000
    if b <> 0 then filewrite(testfile, c , 2)   // UTF-16LE filewrite(testfile, c , 1)
              else filewrite(testfile, d , 2);
    t := t shl 1;                       // Vtg
  end;
end;

function getbit: byte;                  // 1bitǂݍ
var
  c : word;
begin
  if getcount > 0 then begin            // getcount  0 傫
    dec(getcount);                      // fNg
  end
  else begin                            // getcount  0 
    getcount := CHARBITS - 1;           // 7
    fileread(infile, bitbuf, 1);        // 1oCgobt@ɓǂݍ
  end;
  result := (bitbuf shr getcount) and 1;        // getcountrbgEVtg rbĝݎo

  if Form1.CheckBox1.Checked = true then begin  // treeȉ̃rbgo
    if WBF and 2 = 2 then begin                 // 擪>  mFp
      c := 62;                                  // '>'
      filewrite(testfile, c , 2);
      WBF := WBF and 1;
    end;
    if WBF and 1 = 1 then begin
      if result > 0 then c := 49                // '1'
                    else c := 48;               // '0'
      filewrite(testfile, c , 2);               // UTF-16LE filewrite(testfile, c , 1)
    end;
  end;
end;

function getbits(n : byte): byte;     // nbitǂݍ
var
  x : byte;
begin
  x := 0;
  while n > getcount  do begin
    n := n - getcount;
    x := x or (rightbits(getcount, bitbuf) shl n); // bitbuf̉getcountonVtg x or
    fileread(infile, bitbuf, 1);                   // 1oCgǂݍ
    getcount := CHARBITS;                          // 8rbg
  end;
  getcount := getcount - n;
  result := x or (rightbits(n, bitbuf shr getcount)); // bitbufgetcountEVtg nrbgo x or
end;

function putbit(bit : byte): integer;     // 1bit@o  0 s 1
begin                                     // bitbuf1rbgǉ 8rbgɒB1bytet@Cɏo
  result := 0;
  dec(putcount);
  if bit <> 0 then bitbuf := bitbuf or (1 shl putcount); // bit[łȂ1putcountVtg bitbufor
  if putcount = 0 then begin                             // putcount[
    if filewrite(outfile, bitbuf, 1) <= 0 then begin     // bitbuf
      error(pchar('܂'));
      result := 1;                        // putbit error = 1
      exit;
    end;

    if Form1.CheckBox1.Checked = True then testbitout;   // o̓rbgmFp

    bitbuf := 0;                                         // ݂obitbufNA
    putcount := CHARBITS;                                // putcount8rbgɃZbg
    inc(outcount);                                       // ݃oCgJEgAbv
  end;
end;

function putbits(n, x : byte): integer;   // x̒lnbitǉo  0 s 2
begin                                     // bitbufnrbgǉ邪8rbg𒴂ꍇ
  result := 0;                            // 擪8rbgo]bitbuf̐擪Ɉړc
  while n >= putcount do begin            // ݃rbgnƓ
    n := n - putcount;                    // n݃rbgʒu
    bitbuf := bitbuf or rightbits(putcount, x shr n); // xnEVtgputcountobitbufor
    if filewrite(outfile, bitbuf, 1) <= 0 then begin  // bitbuf 1oCg
      error(pchar('܂'));
      result := 2;                        // putbits error 2
      break;
    end;

    if Form1.CheckBox1.Checked = True then testbitout; // o̓rbgmFp

    bitbuf := 0;                                      // ݂obitbufNA
    putcount := CHARBITS;                             // putcount8rbgɃZbg
    inc(outcount);                                    // ݃oCgJEgAbv
  end;
  if result = 2 then exit;                // ݃G[I
  putcount := putcount - n;
  bitbuf := bitbuf or (rightbits(n, x) shl putcount); // x牺nrbgobitbufor
end;

procedure downheap(i : integer);          // D҂sɑ}
var
  j, k : integer;
begin
  k := heap[i];                           // kɈꎞۑ
  repeat                                  // o{
    j := i + i;                           // j = 2 * i
    if j <= heapsize then begin
      if (j < heapsize) and (freq[heap[j]] > freq[heap[j + 1]]) then inc(j);
      if freq[k] <= freq[heap[j]] then break; // k̕pxheap[j]̕px菬ȂI
      heap[i] := heap[j];                 // ւ
      i := j;
    end;
  until j > heapsize;
  heap[i] := k;                           // kVʒu
end;

function  writetree(i : integer): integer;  //  }o   0 s 3
var
  m : integer;
begin
  result := 3;                    // writetree error = 3
  if TReeF = 1 then exit;
  TReeF := 1;
  if i < N then begin             // t
    if putbit(0) > 0 then exit;             // bit=0  G[LI
    if putbits(CHARBITS, i) > 0 then exit;  // 8bis(i)R[h G[LI
    TReeF := 0;
  end
  else begin                      // 
    if putbit(1) > 0 then exit;             // bit=1  G[LI
    TReeF := 0;
    m := i - N;
    writetree(left[m]);           // ̎}
    writetree(right[m]);          // E̎}
  end;
  result := 0;
end;

procedure encode;                 // k
var
  i, j, k, avail, tablesize, jr, c, m : integer;
  ir : byte;
  incount : cardinal;
  codebit : array[0..N-1] of byte;      // 
  cf : double;
begin
  for i := 0 to MNSIZE do freq[i] := 0;  // pxNA
  repeat
    j := fileread(infile, ir, 1);       // oCgǂݍ
    if j > 0 then inc(freq[ir])         // ǂ߂px
  until j <= 0;
  heap[1] := 0;                         // [̃t@Cɔ
  heapsize := 0;
  for i := 0 to N - 1 do begin          // D҂sɓo^
    if freq[i] <> 0 then begin          // el(0`$FF̏o[Ŗ
      inc(heapsize);
      heap[heapsize] := i               // o[Ŗ̂ƂȂ܂
    end;
  end;
  for i := heapsize div 2 downto 1 do downheap(i);  // q[v
  for i := 0 to MNSIZE do parent[i] := 0;        // ؃NA
  k := heap[1];                         // ȉ̃[vsȂꍇɔ
  avail := N;                           // ȉ̃[vŃnt}؂쐬 256`
  while heapsize > 1 do begin           // 2ȏc肪
    i := heap[1];                       // ŏ̗vfo
    heap[1] := heap[heapsize];
    dec(heapsize);
    downheap(1);                        // q[vč\z
    j := heap[1];                       // ɍŏ̗vfo
    k := avail;                         // V߂̐  256`
    inc(avail);
    freq[k] := freq[i] + freq[j];       // pxv freqz256`ɕۑ
    heap[1] := k;
    downheap(1);                        // ҂sɓo^
    parent[i] := k;                     // ؂
    parent[j] := -k;
    m := k - N;                         // k = 256`510
    left[m] := i;                       // ̎}
    right[m] := j;                      // E̎}
  end;
  TReeF := 0;                           // ؂o̓G[tONA
  putcount  := CHARBITS;                // ŏ̃X^[g8rbg
  c := writetree(k);                    // ؂o
  if c > 0 then begin
    Form1.Memo1.Lines.Append('treȅo͂Ɏs܂B');
    exit;
  end;
  tablesize := outcount;                // \̑傫
  incount := 0;
  fileseek(infile, 0, 0);               // đ t@C̐擪ɓǂݎZbg
  repeat                                // GR[ho
    jr := fileread(infile, ir, 1);      // oCgǂݍir
    if jr > 0 then begin                // ǂݍ߂ GR[h
      k := 0;                           // rbgNA
      j := parent[ir];
      while j <> 0 do begin             // rbgGR[h
        if j > 0 then begin
          codebit[k] := 0;
        end
        else begin
          codebit[k] := 1;
          j := -j;
        end;
        inc(k);
        j := parent[j];
      end;
      for i := k - 1 downto 0 do begin  // o sbgk
        c := putbit(codebit[i]);        // rbgo
        if c > 0 then break;
      end;
      inc(incount);                     // ǂݍ񂾃oCgJEg
    end;
  until (jr <= 0) or (c > 0);           // ǂݍ߂Ȃ  o͎sI
  i := putbits(CHARBITS - 1, 0);        // bitbufɎc肪Lco sbit=0ǉ
  if (c > 0) or (i > 0) then begin
    Form1.Memo1.Lines.Append('GR[hɎs܂B');
    exit;
  end;
  Form1.Memo1.Lines.Append('In=' + intTostr(incount));
  Form1.Memo1.Lines.Append('OUT=' + intTostr(outcount) + '  '
                                  + 'table ' + inttostr(tablesize));
  if incount <> 0 then begin                  // k̕\
    cf := (1000 * outcount + incount / 2) / incount;
    cf := round(cf);
    cf := cf / 1000;
    Form1.Memo1.Lines.Append('Out / in =' + floatTostr(cf));
  end;
end;

function readtree: integer;       // ؂ǂ
var
  i, m : integer;
begin
  if getbit > 0 then begin        // bit = 1 tłȂ
    i := avail;                   // ċÄavail̓O[oϐ
    inc(avail);
    if i > MNSIZE then begin
      error(pchar('\ԈĂ܂'));
      result := MNSIZE + 1;
      exit;
    end;
    m := i - N;
    left[m] := readtree;            // ̎}ǂ
    right[m] := readtree;           // E̎}ǂ
    result := i;                    // ߂̒lԂ
  end
  else begin
    result := getbits(CHARBITS);    // 8rbg()擾
  end;
end;

procedure decode(size : integer);              // 
var
  j, root, c, ck : integer;
  k, m : integer;
begin
  WBF := 0;                                     // rbgoZbg
  c := 1;
  ck := 0;
  avail := N;
  root := readtree;                             // ؂ǂ
  if root > MNSIZE then exit;                   // ؂̕\ԈĂ̂ŏI
  for k := 0 to size - 1 do begin               // eǂ
    WBF := 3;                                   // mFprbgDZbg
    j := root;                                  //  j = 0 ` 510 (8bit)ނ
    while j >= N do begin                       // ꍇ͎}oȂ̂ j < N
      m := j - N;                               // j = 256`510  m = 0`254
      if getbit > 0 then j := right[m]          // right[0..254] left[0..254]
                    else j := left[m];
    end;
    c := filewrite(outfile, j, 1);
    if c <= 0 then begin                        // ߂Ȃł؂
      ck := k;
      break;
    end;
  end;
  if c <= 0 then begin
    Form1.Memo1.Lines.Append('ł؂oCg = ' + inttostr(ck));
  end
  else
    Form1.Memo1.Lines.Append('oCg = ' + inttostr(size)); // oCg
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  size, check         : integer;
  comp, text, bitstr  : string;
begin
  comp := 'd.comp';         // kt@C
  text := 'out.txt';        // WJt@C
  bitstr := 'inbits.txt';
  infile := fileopen(comp, fmOpenRead);           // ͈kt@C0pen
  if infile = INVALID_HANDLE_VALUE then begin
    error(pchar('kt@CJ܂B'));
    exit;
  end;
  outfile := filecreate(text, fmOpenWrite, 0);   // o̓t@C쐬 ̃t@Copen@
  if outfile = INVALID_HANDLE_VALUE then begin
    error(pchar('WJt@CJ܂B'));
    fileclose(infile);
    exit;
  end;
  check := fileread(infile, size, sizeof(size));    // 擪猳t@C̃TCYǂݍ
  if check < 0 then begin
    error(pchar('kt@Cǂ݂܂B'));
    fileclose(infile);
    fileclose(outfile);
    exit;
  end;
  if checkbox1.Checked = True then begin            // bito͊mFȂ
    testfile := filecreate(bitstr, fmOpenWrite, 0);
    if testfile = INVALID_HANDLE_VALUE then begin
      error(pchar('rbgeXgoutt@CJ܂B'));
      fileclose(infile);
      fileclose(outfile);
      exit;
    end;
  end;
  getcount := 0;                                // 
  decode(size);                                 // fR[h
  fileclose(infile);
  fileclose(outfile);
  if checkbox1.Checked = True then fileclose(testfile);   // bito͊mFȂ
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  size                : integer;
  comp, text, bitstr  : string;
begin
  text  := 'in.txt';        // ̓t@C
  comp := 'd.comp';         // kt@C@
  bitstr := 'outbits.txt';
  infile := fileopen(text, fmOpenRead);          // ̓t@Copen
  if infile = INVALID_HANDLE_VALUE then begin
    error(pchar('̓t@CJ܂B'));
    exit;
  end;
  outfile := filecreate(comp, fmOpenWrite, 0);  // o̓t@C쐬 ̃t@Copen@
  if outfile = INVALID_HANDLE_VALUE then begin
    error(pchar('kt@CJ܂B'));
    fileclose(infile);
    exit;
  end;
  if checkbox1.Checked = True then begin        // bito͊mFȂ
    testfile := filecreate(bitstr, fmOpenWrite, 0);
    if testfile = INVALID_HANDLE_VALUE then begin
      error(pchar('rbgeXgoutt@CJ܂B'));
      fileclose(infile);
      fileclose(outfile);
      exit;
    end;
  end;
  memo1.Clear;
  outcount  := 0;                               // 
  getcount  := 0;
  bitbuf    := 0;
  size := fileseek(infile, 0, 2);               // infile t@CTCY擾
  if size < 0 then begin
    error(pchar('̓t@Cǂ߂܂B'));
    fileclose(infile);
    fileclose(outfile);
    exit;
  end;
  if filewrite(outfile, size, sizeof(size)) < 0 then begin  // outfile t@CTCY
    error(pchar('kt@C߂܂B'));
    fileclose(infile);
    fileclose(outfile);
    exit;
  end;
  fileseek(infile, 0, 0);                       // infile t@Cʒu擪
  encode;                                       // GR[h
  if TReeF = 0 then begin
    fileclose(infile);
    fileclose(outfile);
    if checkbox1.Checked = True then fileclose(testfile);   // bito͊mFȂ
  end;
end;

end.
